*
      SUBROUTINE CAZ_HEEV1(NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE,
     $                   NB, VL, VU, IL, IU, ABSTOL, INFILEA, OUTFILE)
*
*      (PZHEEV1, PZHEEV3,PZHEEV5)
*       QL-  QR - 
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, IL, IU
      DOUBLE COMPLEX     AMEM( MEMSIZE )
      DOUBLE PRECISION   VL, VU, ABSTOL
      CHARACTER*(*)      INFILEA, OUTFILE, NAME, UPLO
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            ANB, CTXT, I, IAM, INFO, IPA,
     $                   IPW, IPWOR,IPRWOR,
     $                   IPIWOR, NP, NQ, M, MYCOL, MYROW, MXNP, MXNQ,
     $                   NEIG, NN, NZ, LWOPT, LWORK, LRWORK, LIWORK,
     $                   IA, JA, NPROCS, NPS, MMIN, WORKSIZ
*
*  
      INTEGER            DESCA( 9 )
*  
      DOUBLE PRECISION   W(N)
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZLAPRNT, PZLAREAD,
     $                   PZLAWRITE,
     $                   PZHEEV1, PZHEEV3, PZHEEV5
*
*  
      INTRINSIC          ABS, DBLE, MAX, MIN
*
*  
*
*  
*
      IA = 1
      JA = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A
*
      CALL DESCINIT(DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*     WORK
      IPWOR = IPA + DESCA(9)*NQ
*     WW
*
      LWORK = 5*N + MAX( NB*( NP + 1 ), 3*NB ) + 1
      LRWORK = 2*N
      IPRWOR = IPWOR + LWORK
      IPW = IPRWOR + LRWORK
*
      IF( NAME .NE. 'PZHEEV3' .AND. NAME .NE. 'PZHEEV5' ) GOTO 5
*
*   ,    PZHEEV3(5)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
*
      LWMIN = N + MAX( NB*( NP0+1 ), 3 )
      LWORK = LWMIN
*
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
      NN = MAX( N, NB, 2 )
      LRWORK = 5*NN + 4*N
*
*     IWORK
      IPRWOR = IPWOR + LWORK
      IPIWOR = IPRWOR + LRWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
    5 IF( NAME .NE. 'PZHEEV1' ) GOTO 10
*
      GOTO 3
*
*     PZLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'  IPA,  IPWOR, IPRWOR, IPW, MMIN'
         WRITE( NPR, FMT = 9994 )IPA,  IPWOR, IPRWOR, IPW, MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
*        A
*
      CALL PZLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
*
 9994 FORMAT( / 5I6 /)
 9985 FORMAT( / 9I5 /)
*
      CALL PZLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
*     
*
      IF( NAME .EQ. 'PZHEEV3' ) GOTO 11
      IF( NAME .EQ. 'PZHEEV5' ) GOTO 12
      IF( NAME .NE. 'PZHEEV1' ) GOTO 10
*
      CALL PZHEEV1( UPLO, N, AMEM(IPA), IA, JA, DESCA,
     $              W(1), AMEM(IPWOR), LWORK,
     $              AMEM(IPRWOR), LRWORK, INFO )
      GOTO 99
*
   11 CALL PZHEEV3( UPLO, N, AMEM(IPA), IA, JA, DESCA, VL, VU, ABSTOL,
     $              M, W(1), AMEM(IPWOR), LWORK,
     $              AMEM(IPRWOR), LRWORK, AMEM(IPIWOR), LIWORK, INFO)
      GOTO 99
*
   12 CALL PZHEEV5( UPLO, N, AMEM(IPA), IA, JA, DESCA, IL, IU, ABSTOL,
     $              M, W(1), AMEM(IPWOR), LWORK,
     $              AMEM(IPRWOR), LRWORK, AMEM(IPIWOR), LIWORK, INFO)
      GOTO 99
*
*  
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9995 )INFO, UPLO
      IF( NAME .NE. 'PZHEEV3' ) GOTO 15
         WRITE( NPR, FMT = 9991 ) VL, VU
   15 IF( NAME .NE. 'PZHEEV5' ) GOTO 16
         WRITE( NPR, FMT = 9989 ) IL, IU
   16 IF( NAME .EQ. 'PZHEEV1' ) GOTO 14
      WRITE( NPR, FMT = 9993 ) ABSTOL
      WRITE( NPR, FMT = 9990 ) M
*
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
*
   14   WRITE( NPR, FMT = * ) '  '
      IF( NAME .NE. 'PZHEEV1' ) GOTO 17
        NEX = N
        GOTO 23
   17   NEX = M
*
   23    DO 18 I = 1, NEX
         PRINT *, ' W(', I, ')=', W( I ), ';'
   18   CONTINUE
      END IF
*
 9989 FORMAT( / ' IL = ', I5, ' IU = ', I5 / )
 9991 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 /)
 9990 FORMAT( / ' M = ', I5 /)
*** 9999 FORMAT( /' W =', 2D20.12/ )
*
*     
*
   19 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
         WRITE(NOUT, FMT = *)' '
*
      IF( NAME .NE. 'PZHEEV3' .AND. NAME .NE. 'PZHEEV5' ) GOTO 22
         WRITE(NOUT, FMT = *) M, 1
         DO 21 I = 1, M
            WRITE( NOUT, FMT = * ) W( I )
   21    CONTINUE
      GO TO 10
*
   22    WRITE(NOUT, FMT = *) N, 1
         DO 27 I = 1, N
            WRITE( NOUT, FMT = * ) W( I )
   27    CONTINUE
*
      END IF
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'     ,',//,
     $       '  A -   ',I2,' ',I2,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( / '  INFO =', I6, '    UPLO  = ', A1 /)
* 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
